
/**
 * A utility class of nodes to be used in implementing linked lists.
 * Nodes are indexed by ints, rather than references to the other nodes.
 * These nodes are thus best used in an array-based implemenation of a list.
 *
 * @author Zach Tomaszewski
 * @date 06 Oct 2001
 * @see ListArrayBasedLinks
 */

class ArrayNode {
   private Object item;  //the item each node will contain
   private int nextNode;

 protected ArrayNode(Object item, int nextNode) {
   this.item = item;
   this.nextNode = nextNode;
 }

 protected ArrayNode(Object item){
   this.item = item;
   this.nextNode = -1;
 }

 /**
  * returns the next node in the list
  */
 protected int getNext(){
   return this.nextNode;
 }


 /**
  * returns the object contained by this node
  */
 protected Object getItem(){
   return this.item;
 }


 /**
  * updates the link from this node to the next
  */
 protected void setNext(int nextNode){
   this.nextNode = nextNode;
 }

 /**
  * removes the link from this node to the next (sets it to null) 
  */
 protected void removeNext() {
    this.nextNode = -1;
 }
}

